.486
.model flat, stdcall
option casemap :none

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib

.data

    hFile          DWORD   0
    FileLength     DWORD   0
    pDataBuffer    DWORD   0
    BytesRead      DWORD   0
    BytesWritten   DWORD   0

    DataBuffer     BYTE    64 dup (0)
    FileName       BYTE    "c:\testfile.txt", 0
    szDlgTitle     BYTE    "API File Access...", 0
    szMsgReadErr   BYTE    "Reading Failed", 0
    szMsgWriteErr  BYTE    "Writing Failed", 0
    szMsgAllDone   BYTE    "All Done", 0

.code

start:

    INVOKE CreateFile, ADDR FileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        MOV hFile, eax

    INVOKE GetFileSize, hFile, FileLength
        MOV FileLength, eax

    INVOKE ReadFile, hFile, ADDR DataBuffer, FileLength, BytesRead, NULL
        JZ ProgramReadError

    LEA eax, DataBuffer
    MOV pDataBuffer, eax
    ADD eax, FileLength

    DataModifyingLoop:
        ADD [pDataBuffer], 01010101h
        ADD pDataBuffer, 4
        CMP pDataBuffer, eax
        JNAE DataModifyingLoop

    INVOKE WriteFile, hFile, ADDR DataBuffer, FileLength, BytesWritten, NULL
        JZ ProgramWriteError

    ProgramEnd:
        INVOKE CloseHandle, hFile
        INVOKE MessageBox, NULL, ADDR szMsgAllDone, ADDR szDlgTitle, MB_OK
        INVOKE ExitProcess, NULL

    ProgramReadError:
        INVOKE MessageBox, NULL, ADDR szMsgReadErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

    ProgramWriteError:
        INVOKE MessageBox, NULL, ADDR szMsgWriteErr, ADDR szDlgTitle, MB_OK 
        JMP ProgramEnd

end start
